/*
 * ---------------------------------------------------------
 *
 * Simple program to show how to copy a memory block with 
 * master transfer to the userspace.
 *
 * ---------------------------------------------------------
 */
#include "../mv1.h"
int
main() {
	MV1_Ctrl *bd=MV1_Open(0);
	MV1_GrabWindow gw;
	volatile void *dst;
	u_long len;
	int i,count;
	double Sleep = 1;

	// Transfer the whole grabwindow, no matter how big the frame is
	MV1_InquireGrabWindow(&gw,bd);
	len = gw.dx * gw.dy; 

	dst =  MV1_MasterMalloc(len,bd);
       	fprintf(stderr,"dst: %p, Wert 0x%08x\n",dst,*((unsigned int*)(dst+10004)));
 //      	*((unsigned int*)(dst+1000)) = 5;
       	fprintf(stderr,"dst: %p, Wert 0x%08x\n",dst,*((unsigned int*)(dst+10004)));
//       	*((unsigned int*)(dst+1000)) = 5;
       	fprintf(stderr,"dst: %p, Wert 0x%08x, LINE %d\n",dst,*((unsigned int*)(dst+10004)),__LINE__);
	if(dst==0) {
		fprintf(stderr,"out of memory\n");
		exit(1);
	}
       	fprintf(stderr,"dst: %p, Wert 0x%08x, LINE %d\n",dst,*((unsigned int*)(dst+10004)),__LINE__);

	/*
         * ----------------------------
	 *
	 * Fill the transfer list
         *
 	 * ----------------------------
	 */
        MV1_SetMasterLoop(1,bd);
        MV1_SetMasterWaitFrame(0,bd); // don't wait until a frame is grabbed
				      // because this is a speedtest

	MV1_SetTransferEndIrq(1,bd);
        MV1_SetMasterEnable(1,bd); // is stopped automatically on every unmap of master mem
	for(i=0;i<10000;i++) {
        	count = MV1_InquireTransferEndCount(bd);

        	// Change this for longer test
        	sleep(Sleep);
        	count = MV1_InquireTransferEndCount(bd)-count;
        	fprintf(stderr,"loop %d: transfered %d frames in %f seconds\n",i,count,Sleep);
        	fprintf(stderr,"amount data %f MBytes per second\n",(len/Sleep/1e6)*count);
        	fprintf(stderr,"dst: %p, Wert 0x%08x\n",dst,*(unsigned int*)(dst+10004));
	}
	exit(0);
}
